## libgit2 0.19.0

=== CMakeLists.txt ===
# CMake build script for the libgit2 project
#
# Building (out of source build):
# > mkdir build && cd build
# > cmake .. [-DSETTINGS=VALUE]
# > cmake --build .
#
# Testing:
# > ctest -V
#
# Install:
# > cmake --build . --target install

PROJECT(libgit2 C)
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

# Add find modules to the path
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Build options
#
OPTION( SONAME				"Set the (SO)VERSION of the target"		ON  )
OPTION( BUILD_SHARED_LIBS	"Build Shared Library (OFF for Static)"	ON  )
OPTION( THREADSAFE			"Build libgit2 as threadsafe"			OFF )
OPTION( BUILD_CLAR			"Build Tests using the Clar suite"		ON  )
OPTION( BUILD_EXAMPLES		"Build library usage example apps"		OFF )
OPTION( TAGS				"Generate tags"							OFF )
OPTION( PROFILE				"Generate profiling information"		OFF )
OPTION( ENABLE_TRACE		"Enables tracing support"				OFF )
OPTION( LIBGIT2_FILENAME	"Name of the produced binary" OFF )

IF(MSVC)
	# This option is only availalbe when building with MSVC. By default,
	# libgit2 is build using the stdcall calling convention, as that's what
	# the CLR expects by default and how the Windows API is built.
	#
	# If you are writing a C or C++ program and want to link to libgit2, you
	# have to either:
	# - Add /Gz to the compiler options of _your_ program / library.
	# - Turn this off by invoking CMake with the "-DSTDCALL=Off" argument.
	#
	OPTION( STDCALL			"Build libgit2 with the __stdcall convention"	ON  )

	# This option must match the settings used in your program, in particular if you
	# are linking statically
	OPTION( STATIC_CRT		"Link the static CRT libraries"	ON  )
ENDIF()

# Installation paths
#
SET(BIN_INSTALL_DIR bin CACHE PATH "Where to install binaries to.")
SET(LIB_INSTALL_DIR lib CACHE PATH "Where to install libraries to.")
SET(INCLUDE_INSTALL_DIR include CACHE PATH "Where to install headers to.")

FUNCTION(TARGET_OS_LIBRARIES target)
	IF(WIN32)
		TARGET_LINK_LIBRARIES(${target} ws2_32)
	ELSEIF(CMAKE_SYSTEM_NAME MATCHES "(Solaris|SunOS)")
		TARGET_LINK_LIBRARIES(${target} socket nsl)
	ENDIF ()
	IF(THREADSAFE)
		TARGET_LINK_LIBRARIES(${target} ${CMAKE_THREAD_LIBS_INIT})
	ENDIF()
ENDFUNCTION()

# For the MSVC IDE, this function splits up the source files like windows
# explorer does. This is esp. useful with the libgit2_clar project, were
# usually 2 or more files share the same name.  Sadly, this file grouping
# is a per-directory option in cmake and not per-target, resulting in
# empty virtual folders "tests-clar" for the git2.dll
FUNCTION(MSVC_SPLIT_SOURCES target)
	IF(MSVC_IDE)
		GET_TARGET_PROPERTY(sources ${target} SOURCES)
		FOREACH(source ${sources})
			IF(source MATCHES ".*/")
				STRING(REPLACE ${CMAKE_CURRENT_SOURCE_DIR}/ "" rel ${source})
				IF(rel)
					STRING(REGEX REPLACE "/([^/]*)$" "" rel ${rel})
					IF(rel)
						STRING(REPLACE "/" "\\\\" rel ${rel})
						SOURCE_GROUP(${rel} FILES ${source})
					ENDIF()
				ENDIF()
			ENDIF()
		ENDFOREACH()
	ENDIF()
ENDFUNCTION()

FILE(STRINGS "include/git2/version.h" GIT2_HEADER REGEX "^#define LIBGIT2_VERSION \"[^\"]*\"$")

STRING(REGEX REPLACE "^.*LIBGIT2_VERSION \"([0-9]+).*$" "\\1" LIBGIT2_VERSION_MAJOR "${GIT2_HEADER}")
STRING(REGEX REPLACE "^.*LIBGIT2_VERSION \"[0-9]+\\.([0-9]+).*$" "\\1" LIBGIT2_VERSION_MINOR  "${GIT2_HEADER}")
STRING(REGEX REPLACE "^.*LIBGIT2_VERSION \"[0-9]+\\.[0-9]+\\.([0-9]+).*$" "\\1" LIBGIT2_VERSION_REV "${GIT2_HEADER}")
SET(LIBGIT2_VERSION_STRING "${LIBGIT2_VERSION_MAJOR}.${LIBGIT2_VERSION_MINOR}.${LIBGIT2_VERSION_REV}")

# Find required dependencies
INCLUDE_DIRECTORIES(src include)

IF (WIN32 AND NOT MINGW)
	ADD_DEFINITIONS(-DGIT_WINHTTP)
ELSE ()
	IF (NOT AMIGA)
		FIND_PACKAGE(OpenSSL)
	ENDIF ()

	FIND_PACKAGE(HTTP_Parser QUIET)
	IF (HTTP_PARSER_FOUND AND HTTP_PARSER_VERSION_MAJOR EQUAL 2)
		INCLUDE_DIRECTORIES(${HTTP_PARSER_INCLUDE_DIRS})
		LINK_LIBRARIES(${HTTP_PARSER_LIBRARIES})
	ELSE()
		MESSAGE("http-parser was not found or is too old; using bundled 3rd-party sources.")
		INCLUDE_DIRECTORIES(deps/http-parser)
		FILE(GLOB SRC_HTTP deps/http-parser/*.c)
	ENDIF()
ENDIF()

# Specify sha1 implementation
IF (WIN32 AND NOT MINGW AND NOT SHA1_TYPE STREQUAL "builtin")
	ADD_DEFINITIONS(-DWIN32_SHA1)
	FILE(GLOB SRC_SHA1 src/hash/hash_win32.c)
ELSEIF (OPENSSL_FOUND AND NOT SHA1_TYPE STREQUAL "builtin")
	ADD_DEFINITIONS(-DOPENSSL_SHA1)
ELSE()
	FILE(GLOB SRC_SHA1 src/hash/hash_generic.c)
ENDIF()

# Enable tracing
IF (ENABLE_TRACE STREQUAL "ON")
	ADD_DEFINITIONS(-DGIT_TRACE)
ENDIF()

# Include POSIX regex when it is required
IF(WIN32 OR AMIGA)
	INCLUDE_DIRECTORIES(deps/regex)
	SET(SRC_REGEX deps/regex/regex.c)
ENDIF()

# Optional external dependency: zlib
# It's optional, but FIND_PACKAGE gives a warning that looks more like an
# error.
FIND_PACKAGE(ZLIB QUIET)
IF (ZLIB_FOUND)
	INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIRS})
	LINK_LIBRARIES(${ZLIB_LIBRARIES})
	# Fake the message CMake would have shown
	MESSAGE("-- Found zlib: ${ZLIB_LIBRARY}")
ELSE()
	MESSAGE( "zlib was not found; using bundled 3rd-party sources." )
	INCLUDE_DIRECTORIES(deps/zlib)
	ADD_DEFINITIONS(-DNO_VIZ -DSTDC -DNO_GZIP)
	FILE(GLOB SRC_ZLIB deps/zlib/*.c)
ENDIF()

IF(NOT LIBSSH2_LIBRARY)
	FIND_PACKAGE(LIBSSH2 QUIET)
ENDIF()
IF (LIBSSH2_FOUND)
	ADD_DEFINITIONS(-DGIT_SSH)
	INCLUDE_DIRECTORIES(${LIBSSH2_INCLUDE_DIR})
	SET(SSH_LIBRARIES ${LIBSSH2_LIBRARIES})
ENDIF()

# Platform specific compilation flags
IF (MSVC)

	STRING(REPLACE "/Zm1000" " " CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")

	# /GF - String pooling
	# /MP - Parallel build
	SET(CMAKE_C_FLAGS "/GF /MP /nologo ${CMAKE_C_FLAGS}")

	IF (STDCALL)
		# /Gz - stdcall calling convention
		SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /Gz")
	ENDIF ()

	IF (STATIC_CRT)
		SET(CRT_FLAG_DEBUG "/MTd")
		SET(CRT_FLAG_RELEASE "/MT")
	ELSE()
		SET(CRT_FLAG_DEBUG "/MDd")
		SET(CRT_FLAG_RELEASE "/MD")
	ENDIF()

	# /Zi - Create debugging information
	# /Od - Disable optimization
	# /D_DEBUG - #define _DEBUG
	# /MTd - Statically link the multithreaded debug version of the CRT
	# /MDd - Dynamically link the multithreaded debug version of the CRT
	# /RTC1 - Run time checks
	SET(CMAKE_C_FLAGS_DEBUG "/Zi /Od /D_DEBUG /RTC1 ${CRT_FLAG_DEBUG}")

	# /DNDEBUG - Disables asserts
	# /MT - Statically link the multithreaded release version of the CRT
	# /MD - Dynamically link the multithreaded release version of the CRT
	# /O2 - Optimize for speed
	# /Oy - Enable frame pointer omission (FPO) (otherwise CMake will automatically turn it off)
	# /GL - Link time code generation (whole program optimization)
	# /Gy - Function-level linking
	SET(CMAKE_C_FLAGS_RELEASE "/DNDEBUG /O2 /Oy /GL /Gy ${CRT_FLAG_RELEASE}")

	# /Oy- - Disable frame pointer omission (FPO)
	SET(CMAKE_C_FLAGS_RELWITHDEBINFO "/DNDEBUG /Zi /O2 /Oy- /GL /Gy ${CRT_FLAG_RELEASE}")

	# /O1 - Optimize for size
	SET(CMAKE_C_FLAGS_MINSIZEREL "/DNDEBUG /O1 /Oy /GL /Gy ${CRT_FLAG_RELEASE}")

	# /DYNAMICBASE - Address space load randomization (ASLR)
	# /NXCOMPAT - Data execution prevention (DEP)
	# /LARGEADDRESSAWARE - >2GB user address space on x86
	# /VERSION - Embed version information in PE header
	SET(CMAKE_EXE_LINKER_FLAGS "/DYNAMICBASE /NXCOMPAT /LARGEADDRESSAWARE /VERSION:${LIBGIT2_VERSION_MAJOR}.${LIBGIT2_VERSION_MINOR}")

	# /DEBUG - Create a PDB
	# /LTCG - Link time code generation (whole program optimization)
	# /OPT:REF /OPT:ICF - Fold out duplicate code at link step
	# /INCREMENTAL:NO - Required to use /LTCG
	# /DEBUGTYPE:cv,fixup - Additional data embedded in the PDB (requires /INCREMENTAL:NO, so not on for Debug)
	SET(CMAKE_EXE_LINKER_FLAGS_DEBUG "/DEBUG")
	SET(CMAKE_EXE_LINKER_FLAGS_RELEASE "/RELEASE /LTCG /OPT:REF /OPT:ICF /INCREMENTAL:NO")
	SET(CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "/DEBUG /RELEASE /LTCG /OPT:REF /OPT:ICF /INCREMENTAL:NO /DEBUGTYPE:cv,fixup")
	SET(CMAKE_EXE_LINKER_FLAGS_MINSIZEREL "/RELEASE /LTCG /OPT:REF /OPT:ICF /INCREMENTAL:NO")

	# Same linker settings for DLL as EXE
	SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS}")
	SET(CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG}")
	SET(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE}")
	SET(CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO}")
	SET(CMAKE_SHARED_LINKER_FLAGS_MINSIZEREL "${CMAKE_EXE_LINKER_FLAGS_MINSIZEREL}")

	SET(WIN_RC "src/win32/git2.rc")

   # Precompiled headers

ELSE ()
	SET(CMAKE_C_FLAGS "-D_GNU_SOURCE -Wall -Wextra -Wno-missing-field-initializers -Wstrict-aliasing=2 -Wstrict-prototypes ${CMAKE_C_FLAGS}")

	IF (WIN32 AND NOT CYGWIN)
		SET(CMAKE_C_FLAGS_DEBUG "-D_DEBUG")
	ENDIF ()

	IF (MINGW) # MinGW always does PIC and complains if we tell it to
		STRING(REGEX REPLACE "-fPIC" "" CMAKE_SHARED_LIBRARY_C_FLAGS "${CMAKE_SHARED_LIBRARY_C_FLAGS}")
		# MinGW >= 3.14 uses the C99-style stdio functions
		# automatically, but forks like mingw-w64 still want
		# us to define this in order to use them
		ADD_DEFINITIONS(-D__USE_MINGW_ANSI_STDIO=1)

	ELSEIF (BUILD_SHARED_LIBS)
		SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden -fPIC")
	ENDIF ()
	IF (APPLE) # Apple deprecated OpenSSL
		SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-deprecated-declarations")
	ENDIF ()
	IF (PROFILE)
		SET(CMAKE_C_FLAGS "-pg ${CMAKE_C_FLAGS}")
		SET(CMAKE_EXE_LINKER_FLAGS "-pg ${CMAKE_EXE_LINKER_FLAGS}")
	ENDIF ()
ENDIF()

IF( NOT CMAKE_CONFIGURATION_TYPES )
	# Build Debug by default
	IF (NOT CMAKE_BUILD_TYPE)
		SET(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
	ENDIF ()
ELSE()
	# Using a multi-configuration generator eg MSVC or Xcode
	# that uses CMAKE_CONFIGURATION_TYPES and not CMAKE_BUILD_TYPE
ENDIF()

IF (OPENSSL_FOUND)
  ADD_DEFINITIONS(-DGIT_SSL)
  INCLUDE_DIRECTORIES(${OPENSSL_INCLUDE_DIR})
  SET(SSL_LIBRARIES ${OPENSSL_LIBRARIES})
ENDIF()

IF (THREADSAFE)
	IF (NOT WIN32)
		find_package(Threads REQUIRED)
	ENDIF()

	ADD_DEFINITIONS(-DGIT_THREADS)
ENDIF()

ADD_DEFINITIONS(-D_FILE_OFFSET_BITS=64)

# Collect sourcefiles
FILE(GLOB SRC_H include/git2/*.h)

# On Windows use specific platform sources
IF (WIN32 AND NOT CYGWIN)
	ADD_DEFINITIONS(-DWIN32 -D_WIN32_WINNT=0x0501)
	FILE(GLOB SRC_OS src/win32/*.c)
ELSEIF (AMIGA)
	ADD_DEFINITIONS(-DNO_ADDRINFO -DNO_READDIR_R)
	FILE(GLOB SRC_OS src/amiga/*.c)
ELSE()
	FILE(GLOB SRC_OS src/unix/*.c)
ENDIF()
FILE(GLOB SRC_GIT2 src/*.c src/transports/*.c src/xdiff/*.c)

# Determine architecture of the machine
IF (CMAKE_SIZEOF_VOID_P EQUAL 8)
	ADD_DEFINITIONS(-DGIT_ARCH_64)
ELSEIF (CMAKE_SIZEOF_VOID_P EQUAL 4)
	ADD_DEFINITIONS(-DGIT_ARCH_32)
ELSE()
	message(FATAL_ERROR "Unsupported architecture")
ENDIF()

# Compile and link libgit2
ADD_LIBRARY(git2 ${SRC_GIT2} ${SRC_OS} ${SRC_ZLIB} ${SRC_HTTP} ${SRC_REGEX} ${SRC_SHA1} ${WIN_RC})
TARGET_LINK_LIBRARIES(git2 ${SSL_LIBRARIES})
TARGET_LINK_LIBRARIES(git2 ${SSH_LIBRARIES})
TARGET_OS_LIBRARIES(git2)

# Workaround for Cmake bug #0011240 (see http://public.kitware.com/Bug/view.php?id=11240)
# Win64+MSVC+static libs = linker error
IF(MSVC AND GIT_ARCH_64 AND NOT BUILD_SHARED_LIBS)
  SET_TARGET_PROPERTIES(git2 PROPERTIES STATIC_LIBRARY_FLAGS "/MACHINE:x64")
ENDIF()

MSVC_SPLIT_SOURCES(git2)

IF (SONAME)
	SET_TARGET_PROPERTIES(git2 PROPERTIES VERSION ${LIBGIT2_VERSION_STRING})
	SET_TARGET_PROPERTIES(git2 PROPERTIES SOVERSION ${LIBGIT2_VERSION_MAJOR})
	IF (LIBGIT2_FILENAME)
		ADD_DEFINITIONS(-DLIBGIT2_FILENAME=\"${LIBGIT2_FILENAME}\")
		SET_TARGET_PROPERTIES(git2 PROPERTIES OUTPUT_NAME ${LIBGIT2_FILENAME})
	ENDIF()
ENDIF()
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/libgit2.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libgit2.pc @ONLY)

IF (MSVC_IDE)
   # Precompiled headers
   SET_TARGET_PROPERTIES(git2 PROPERTIES COMPILE_FLAGS "/Yuprecompiled.h /FIprecompiled.h")
   SET_SOURCE_FILES_PROPERTIES(src/win32/precompiled.c COMPILE_FLAGS "/Ycprecompiled.h")
ENDIF ()

# Install
INSTALL(TARGETS git2
	RUNTIME DESTINATION ${BIN_INSTALL_DIR}
	LIBRARY DESTINATION ${LIB_INSTALL_DIR}
	ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
)

=== examples/Makefile ===
.PHONY: all

CC = gcc
CFLAGS = -g -I../include -I../src -Wall -Wextra -Wmissing-prototypes -Wno-missing-field-initializers
LFLAGS = -L../build -lgit2 -lz
APPS = general showindex diff rev-list cat-file status

all: $(APPS)

% : %.c
	$(CC) -o $@ $(CFLAGS) $< $(LFLAGS)

clean:
	$(RM) $(APPS)
	$(RM) -r *.dSYM

## libgit2 0.17.0

=== debian/changelog ===
libgit2 (0.17.0-1) experimental; urgency=low

  * New Upstream Release.
  * debian/patches/build_static.patch: Enables building as both
    static and dynamic library.
  * debian/rules: Added CMAKE_BUILD_TYPE=RelWithDebInfo to rules file.
  * debian/compat: Updated to 9, adds support for hardening.

 -- Russell Sim <russell.sim@gmail.com>  Sun, 20 May 2012 21:34:12 +1000

libgit2 (0.16.0-1) experimental; urgency=low

  * Initial release (Closes: #614517)

 -- Russell Sim <russell.sim@gmail.com>  Tue, 06 Mar 2012 23:03:20 +1100

=== debian/control ===
Source: libgit2
Section: libs
Priority: extra
Maintainer: Russell Sim <russell.sim@gmail.com>
Build-Depends: debhelper (>= 9.20120417), python-all (>= 2.4.0), cmake, libz-dev
Standards-Version: 3.9.3
Homepage: http://libgit2.github.com/
#Vcs-Git: git://git.debian.org/collab-maint/libgit2.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/libgit2.git;a=summary


Package: libgit2-dev
Architecture: any
Section: libdevel
Depends: libgit2-0 (= ${binary:Version}),
         ${misc:Depends}
Description: low-level Git library (development files)
 libgit2 is a portable, pure C implementation of the Git
 distributed version control system core methods provided as a
 re-entrant link-able library with a solid API.
 .
 This package contains the development files for libgit2.

Package: libgit2-0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: low-level Git library
 libgit2 is a portable, pure C implementation of the Git
 distributed version control system core methods provided as a
 re-entrant link-able library with a solid API.

Package: libgit2-dbg
Section: debug
Architecture: any
Depends: libgit2-0 (= ${binary:Version}),
         ${misc:Depends}
Description: libgit2 library and debugging symbols
 libgit2 is a portable, pure C implementation of the Git
 distributed version control system core methods provided as a
 re-entrant link-able library with a solid API.
 .
 This package contains detached debugging symbols.
 .
 Most people will not need this package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --dbg-package=libgit2-dbg

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_CLAR:BOOL=ON -DBUILD_TESTS:BOOL=ON -DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_makeshlibs:
	dh_makeshlibs -V 'libgit2-0 (>= 0.16.0)'

=== debian/watch ===
version=2
https://github.com/libgit2/libgit2/downloads /downloads/libgit2/libgit2/libgit2-(.+)\.tar\.gz

## libgit2 0.19.0

=== debian/changelog ===
libgit2 (0.19.0-2) experimental; urgency=low

  * Added correct dependencies to development package. (Closes: #715173)
  * Standards upgrade to version 3.9.4.
  * Multi-arch support.
  * Manually specified symbols instead of relying on regex.

 -- Russell Sim <russell.sim@gmail.com>  Wed, 20 Aug 2013 22:33:20 +1000

libgit2 (0.19.0-1) experimental; urgency=low

  * Enable threading. (Closes: #700181)

 -- Russell Sim <russell.sim@gmail.com>  Tue, 02 Jul 2013 19:43:00 +1000

libgit2 (0.18.0-2) experimental; urgency=low

  * Disable online tests.
    Thanks to Felix Geyer for the heads up. (Closes: #712300)

 -- Russell Sim <russell.sim@gmail.com>  Mon, 17 Jun 2013 23:11:15 +1000

libgit2 (0.18.0-1) experimental; urgency=low

  [ Russell Sim ]
  * Added examples to dev package.

  [ Carlos Martín Nieto ]
  * Build-Depend on python-minimal instead of -all
  * BUILD_TESTS isn't used in this project

  [ Russell Sim ]
  * New upstream release 0.18.0.

 -- Russell Sim <russell.sim@gmail.com>  Tue, 30 Apr 2013 00:55:09 +1000

=== debian/control ===
Source: libgit2
Section: libs
Priority: extra
Maintainer: Russell Sim <russell.sim@gmail.com>
Build-Depends: debhelper (>= 9.20120417), python-minimal (>= 2.4.0),
               cmake, libz-dev, libssl-dev, ca-certificates
Standards-Version: 3.9.4
Homepage: http://libgit2.github.com/
Vcs-Git: git://anonscm.debian.org/users/arrsim-guest/libgit2.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/arrsim-guest/libgit2.git;a=summary


Package: libgit2-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libgit2-0 (= ${binary:Version}), libz-dev, libssl-dev,
         ${shlibs:Depends}, ${misc:Depends}
Description: low-level Git library (development files)
 libgit2 is a portable, pure C implementation of the Git
 distributed version control system core methods provided as a
 re-entrant link-able library with a solid API.
 .
 This package contains the development files for libgit2.

Package: libgit2-0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: low-level Git library
 libgit2 is a portable, pure C implementation of the Git
 distributed version control system core methods provided as a
 re-entrant link-able library with a solid API.

Package: libgit2-dbg
Section: debug
Architecture: any
Multi-Arch: same
Depends: libgit2-0 (= ${binary:Version}),
         ${misc:Depends}
Description: libgit2 library and debugging symbols
 libgit2 is a portable, pure C implementation of the Git
 distributed version control system core methods provided as a
 re-entrant link-able library with a solid API.
 .
 This package contains detached debugging symbols.
 .
 Most people will not need this package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# This rules file has 2 streams, the build-debian-devel stream builds
# the static library and the bulid-debian-release builds the dynamic
# library.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build-debian-release -- \
		-DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
		-DTHREADSAFE:BOOL=ON \
		-DBUILD_CLAR:BOOL=ON \
		-DLIB_INSTALL_DIR:STRING=lib/$(DEB_HOST_MULTIARCH)

	dh_auto_configure --builddirectory=build-debian-devel -- \
		-DCMAKE_BUILD_TYPE:STRING=Release \
		-DTHREADSAFE:BOOL=ON \
		-DBUILD_CLAR:BOOL=OFF \
		-DBUILD_SHARED_LIBS:BOOL=OFF \
		-DLIB_INSTALL_DIR:STRING=lib/$(DEB_HOST_MULTIARCH)


override_dh_makeshlibs:
	dh_makeshlibs -V 'libgit2-0 (>= 0.19.0)'

override_dh_auto_build :
	dh_auto_build --builddirectory=build-debian-release
	dh_auto_build --builddirectory=build-debian-devel

override_dh_auto_install :
	dh_auto_install --builddirectory=build-debian-release
	dh_auto_install --builddirectory=build-debian-devel

override_dh_strip:
	dh_strip --dbg-package=libgit2-dbg

override_dh_installexamples:
	dh_installexamples --exclude .gitignore

%:
	dh $@ --parallel --buildsystem cmake --dbg-package=libgit2-dbg --builddirectory=build-debian-release 
	dh $@ --parallel --buildsystem cmake --builddirectory=build-debian-devel

=== debian/watch ===
version=3
https://github.com/libgit2/libgit2/tags /libgit2/libgit2/archive/v(.+)\.tar\.gz

## libgit2 0.20.0

=== debian/changelog ===
libgit2 (0.20.0-1) experimental; urgency=medium

  * New upstream release 0.20.0.
  * debian/patches/disable_online_tests.patch: Renamed to
    disable_tests.patch.
  * debian/patches/disable_tests.patch: Disabled blame test.
  * debian/rules: Use automatic dh_makeshlib version dependency.
  * Bumped standards version to 3.9.5 (no change necessary).
  * debian/copyright: Added new licenses: MIT, BSD and PHP

 -- Russell Sim <russell.sim@gmail.com>  Thu, 13 Mar 2014 20:35:39 +1100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Russell Sim <russell.sim@gmail.com>
 Build-Depends: debhelper (>= 9.20120417), python-minimal (>= 2.4.0),
                cmake, libz-dev, libssl-dev, ca-certificates
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://libgit2.github.com/
 Vcs-Git: git://anonscm.debian.org/users/arrsim-guest/libgit2.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/arrsim-guest/libgit2.git;a=summary

=== debian/rules ===
--- 
+++ 
@@ -26,7 +26,7 @@
 
 
 override_dh_makeshlibs:
-	dh_makeshlibs -V 'libgit2-0 (>= 0.19.0)'
+	dh_makeshlibs -V
 
 override_dh_auto_build :
 	dh_auto_build --builddirectory=build-debian-release
@@ -43,5 +43,5 @@
 	dh_installexamples --exclude .gitignore
 
 %:
-	dh $@ --parallel --buildsystem cmake --dbg-package=libgit2-dbg --builddirectory=build-debian-release 
+	dh $@ --parallel --buildsystem cmake --dbg-package=libgit2-dbg --builddirectory=build-debian-release
 	dh $@ --parallel --buildsystem cmake --builddirectory=build-debian-devel

## libgit2 0.21.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,10 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
 
 # Add find modules to the path
-SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")
+SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")
+
+INCLUDE(CheckLibraryExists)
+INCLUDE(AddCFlagIfSupported)
 
 # Build options
 #
@@ -27,24 +30,48 @@
 OPTION( TAGS				"Generate tags"							OFF )
 OPTION( PROFILE				"Generate profiling information"		OFF )
 OPTION( ENABLE_TRACE		"Enables tracing support"				OFF )
-OPTION( LIBGIT2_FILENAME	"Name of the produced binary" OFF )
+OPTION( LIBGIT2_FILENAME	"Name of the produced binary"			OFF )
+
+OPTION( ANDROID				"Build for android NDK"	 				OFF )
+
+OPTION( USE_ICONV			"Link with and use iconv library" 		OFF )
+OPTION( USE_SSH				"Link with libssh to enable SSH support" ON )
+OPTION( VALGRIND			"Configure build for valgrind"			OFF )
+
+IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+	SET( USE_ICONV ON )
+ENDIF()
 
 IF(MSVC)
-	# This option is only availalbe when building with MSVC. By default,
-	# libgit2 is build using the stdcall calling convention, as that's what
-	# the CLR expects by default and how the Windows API is built.
+	# This option is only available when building with MSVC. By default, libgit2
+	# is build using the cdecl calling convention, which is useful if you're
+	# writing C. However, the CLR and Win32 API both expect stdcall.
 	#
-	# If you are writing a C or C++ program and want to link to libgit2, you
-	# have to either:
-	# - Add /Gz to the compiler options of _your_ program / library.
-	# - Turn this off by invoking CMake with the "-DSTDCALL=Off" argument.
-	#
-	OPTION( STDCALL			"Build libgit2 with the __stdcall convention"	ON  )
+	# If you are writing a CLR program and want to link to libgit2, you'll want
+	# to turn this on by invoking CMake with the "-DSTDCALL=ON" argument.
+	OPTION( STDCALL			"Build libgit2 with the __stdcall convention"	OFF  )
 
 	# This option must match the settings used in your program, in particular if you
 	# are linking statically
 	OPTION( STATIC_CRT		"Link the static CRT libraries"	ON  )
-ENDIF()
+
+	# By default, libgit2 is built with WinHTTP.  To use the built-in
+	# HTTP transport, invoke CMake with the "-DWINHTTP=OFF" argument.
+	OPTION( WINHTTP			"Use Win32 WinHTTP routines"	ON  )
+
+	ADD_DEFINITIONS(-D_SCL_SECURE_NO_WARNINGS)
+	ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)
+	ADD_DEFINITIONS(-D_CRT_NONSTDC_NO_DEPRECATE)
+ENDIF()
+
+# This variable will contain the libraries we need to put into
+# libgit2.pc's Requires.private. That is, what we're linking to or
+# what someone who's statically linking us needs to link to.
+SET(LIBGIT2_PC_REQUIRES "")
+# This will be set later if we use the system's http-parser library or
+# use iconv (OSX) and will be written to the Libs.private field in the
+# pc file.
+SET(LIBGIT2_PC_LIBS "")
 
 # Installation paths
 #
@@ -57,7 +84,14 @@
 		TARGET_LINK_LIBRARIES(${target} ws2_32)
 	ELSEIF(CMAKE_SYSTEM_NAME MATCHES "(Solaris|SunOS)")
 		TARGET_LINK_LIBRARIES(${target} socket nsl)
-	ENDIF ()
+		SET(LIBGIT2_PC_LIBS "${LIBGIT2_PC_LIBS} -lsocket -lnsl" PARENT_SCOPE)
+	ENDIF()
+	CHECK_LIBRARY_EXISTS(rt clock_gettime "time.h" NEED_LIBRT)
+	IF(NEED_LIBRT)
+		TARGET_LINK_LIBRARIES(${target} rt)
+		SET(LIBGIT2_PC_LIBS "${LIBGIT2_PC_LIBS} -lrt" PARENT_SCOPE)
+	ENDIF()
+
 	IF(THREADSAFE)
 		TARGET_LINK_LIBRARIES(${target} ${CMAKE_THREAD_LIBS_INIT})
 	ENDIF()
@@ -67,7 +101,7 @@
 # explorer does. This is esp. useful with the libgit2_clar project, were
 # usually 2 or more files share the same name.  Sadly, this file grouping
 # is a per-directory option in cmake and not per-target, resulting in
-# empty virtual folders "tests-clar" for the git2.dll
+# empty virtual folders "tests" for the git2.dll
 FUNCTION(MSVC_SPLIT_SOURCES target)
 	IF(MSVC_IDE)
 		GET_TARGET_PROPERTY(sources ${target} SOURCES)
@@ -93,24 +127,30 @@
 STRING(REGEX REPLACE "^.*LIBGIT2_VERSION \"[0-9]+\\.[0-9]+\\.([0-9]+).*$" "\\1" LIBGIT2_VERSION_REV "${GIT2_HEADER}")
 SET(LIBGIT2_VERSION_STRING "${LIBGIT2_VERSION_MAJOR}.${LIBGIT2_VERSION_MINOR}.${LIBGIT2_VERSION_REV}")
 
+FILE(STRINGS "include/git2/version.h" GIT2_HEADER_SOVERSION REGEX "^#define LIBGIT2_SOVERSION [0-9]+$")
+STRING(REGEX REPLACE "^.*LIBGIT2_SOVERSION ([0-9]+)$" "\\1" LIBGIT2_SOVERSION "${GIT2_HEADER_SOVERSION}")
+
 # Find required dependencies
 INCLUDE_DIRECTORIES(src include)
 
-IF (WIN32 AND NOT MINGW)
+IF (WIN32 AND WINHTTP AND NOT MINGW)
 	ADD_DEFINITIONS(-DGIT_WINHTTP)
+	INCLUDE_DIRECTORIES(deps/http-parser)
+	FILE(GLOB SRC_HTTP deps/http-parser/*.c deps/http-parser/*.h)
 ELSE ()
 	IF (NOT AMIGA)
 		FIND_PACKAGE(OpenSSL)
 	ENDIF ()
 
-	FIND_PACKAGE(HTTP_Parser QUIET)
+	FIND_PACKAGE(HTTP_Parser)
 	IF (HTTP_PARSER_FOUND AND HTTP_PARSER_VERSION_MAJOR EQUAL 2)
 		INCLUDE_DIRECTORIES(${HTTP_PARSER_INCLUDE_DIRS})
 		LINK_LIBRARIES(${HTTP_PARSER_LIBRARIES})
+		SET(LIBGIT2_PC_LIBS "${LIBGIT2_PC_LIBS} -lhttp_parser")
 	ELSE()
-		MESSAGE("http-parser was not found or is too old; using bundled 3rd-party sources.")
+		MESSAGE(STATUS "http-parser was not found or is too old; using bundled 3rd-party sources.")
 		INCLUDE_DIRECTORIES(deps/http-parser)
-		FILE(GLOB SRC_HTTP deps/http-parser/*.c)
+		FILE(GLOB SRC_HTTP deps/http-parser/*.c deps/http-parser/*.h)
 	ENDIF()
 ENDIF()
 
@@ -120,6 +160,11 @@
 	FILE(GLOB SRC_SHA1 src/hash/hash_win32.c)
 ELSEIF (OPENSSL_FOUND AND NOT SHA1_TYPE STREQUAL "builtin")
 	ADD_DEFINITIONS(-DOPENSSL_SHA1)
+	IF (CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
+		SET(LIBGIT2_PC_LIBS "${LIBGIT2_PC_LIBS} -lssl")
+	ELSE()
+		SET(LIBGIT2_PC_REQUIRES "${LIBGIT2_PC_REQUIRES} openssl")
+	ENDIF ()
 ELSE()
 	FILE(GLOB SRC_SHA1 src/hash/hash_generic.c)
 ENDIF()
@@ -130,34 +175,47 @@
 ENDIF()
 
 # Include POSIX regex when it is required
-IF(WIN32 OR AMIGA)
+IF(WIN32 OR AMIGA OR ANDROID OR CMAKE_SYSTEM_NAME MATCHES "(Solaris|SunOS)")
 	INCLUDE_DIRECTORIES(deps/regex)
 	SET(SRC_REGEX deps/regex/regex.c)
 ENDIF()
 
 # Optional external dependency: zlib
-# It's optional, but FIND_PACKAGE gives a warning that looks more like an
-# error.
-FIND_PACKAGE(ZLIB QUIET)
+FIND_PACKAGE(ZLIB)
 IF (ZLIB_FOUND)
 	INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIRS})
 	LINK_LIBRARIES(${ZLIB_LIBRARIES})
-	# Fake the message CMake would have shown
-	MESSAGE("-- Found zlib: ${ZLIB_LIBRARY}")
+	IF(APPLE OR CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
+		SET(LIBGIT2_PC_LIBS "${LIBGIT2_PC_LIBS} -lz")
+	ELSE()
+		SET(LIBGIT2_PC_REQUIRES "${LIBGIT2_PC_REQUIRES} zlib")
+	ENDIF()
 ELSE()
-	MESSAGE( "zlib was not found; using bundled 3rd-party sources." )
+	MESSAGE(STATUS "zlib was not found; using bundled 3rd-party sources." )
 	INCLUDE_DIRECTORIES(deps/zlib)
 	ADD_DEFINITIONS(-DNO_VIZ -DSTDC -DNO_GZIP)
-	FILE(GLOB SRC_ZLIB deps/zlib/*.c)
-ENDIF()
-
-IF(NOT LIBSSH2_LIBRARY)
-	FIND_PACKAGE(LIBSSH2 QUIET)
+	FILE(GLOB SRC_ZLIB deps/zlib/*.c deps/zlib/*.h)
+ENDIF()
+
+# Optional external dependency: libssh2
+IF (USE_SSH)
+	FIND_PACKAGE(LIBSSH2)
 ENDIF()
 IF (LIBSSH2_FOUND)
 	ADD_DEFINITIONS(-DGIT_SSH)
 	INCLUDE_DIRECTORIES(${LIBSSH2_INCLUDE_DIR})
+	SET(LIBGIT2_PC_REQUIRES "${LIBGIT2_PC_REQUIRES} libssh2")
 	SET(SSH_LIBRARIES ${LIBSSH2_LIBRARIES})
+ENDIF()
+
+# Optional external dependency: iconv
+IF (USE_ICONV)
+	FIND_PACKAGE(Iconv)
+ENDIF()
+IF (ICONV_FOUND)
+	ADD_DEFINITIONS(-DGIT_USE_ICONV)
+	INCLUDE_DIRECTORIES(${ICONV_INCLUDE_DIR})
+	SET(LIBGIT2_PC_LIBS "${LIBGIT2_PC_LIBS} ${ICONV_LIBRARIES}")
 ENDIF()
 
 # Platform specific compilation flags
@@ -233,7 +291,11 @@
    # Precompiled headers
 
 ELSE ()
-	SET(CMAKE_C_FLAGS "-D_GNU_SOURCE -Wall -Wextra -Wno-missing-field-initializers -Wstrict-aliasing=2 -Wstrict-prototypes ${CMAKE_C_FLAGS}")
+	SET(CMAKE_C_FLAGS "-D_GNU_SOURCE -Wall -Wextra ${CMAKE_C_FLAGS}")
+
+	IF (CMAKE_SYSTEM_NAME MATCHES "(Solaris|SunOS)")
+		SET(CMAKE_C_FLAGS "-std=c99 -D_POSIX_C_SOURCE=200112L -D__EXTENSIONS__ -D_POSIX_PTHREAD_SEMANTICS ${CMAKE_C_FLAGS}")
+	ENDIF()
 
 	IF (WIN32 AND NOT CYGWIN)
 		SET(CMAKE_C_FLAGS_DEBUG "-D_DEBUG")
@@ -247,100 +309,23 @@
 		ADD_DEFINITIONS(-D__USE_MINGW_ANSI_STDIO=1)
 
 	ELSEIF (BUILD_SHARED_LIBS)
-		SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden -fPIC")
-	ENDIF ()
+		ADD_C_FLAG_IF_SUPPORTED(-fvisibility=hidden)
+
+		SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
+	ENDIF ()
+
+	ADD_C_FLAG_IF_SUPPORTED(-Wno-missing-field-initializers)
+	ADD_C_FLAG_IF_SUPPORTED(-Wstrict-aliasing=2)
+	ADD_C_FLAG_IF_SUPPORTED(-Wstrict-prototypes)
+	ADD_C_FLAG_IF_SUPPORTED(-Wdeclaration-after-statement)
+	ADD_C_FLAG_IF_SUPPORTED(-Wno-unused-const-variable)
+	ADD_C_FLAG_IF_SUPPORTED(-Wno-unused-function)
+
 	IF (APPLE) # Apple deprecated OpenSSL
-		SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-deprecated-declarations")
-	ENDIF ()
+		ADD_C_FLAG_IF_SUPPORTED(-Wno-deprecated-declarations)
+	ENDIF()
+
 	IF (PROFILE)
 		SET(CMAKE_C_FLAGS "-pg ${CMAKE_C_FLAGS}")
 		SET(CMAKE_EXE_LINKER_FLAGS "-pg ${CMAKE_EXE_LINKER_FLAGS}")
 	ENDIF ()
-ENDIF()
-
-IF( NOT CMAKE_CONFIGURATION_TYPES )
-	# Build Debug by default
-	IF (NOT CMAKE_BUILD_TYPE)
-		SET(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
-	ENDIF ()
-ELSE()
-	# Using a multi-configuration generator eg MSVC or Xcode
-	# that uses CMAKE_CONFIGURATION_TYPES and not CMAKE_BUILD_TYPE
-ENDIF()
-
-IF (OPENSSL_FOUND)
-  ADD_DEFINITIONS(-DGIT_SSL)
-  INCLUDE_DIRECTORIES(${OPENSSL_INCLUDE_DIR})
-  SET(SSL_LIBRARIES ${OPENSSL_LIBRARIES})
-ENDIF()
-
-IF (THREADSAFE)
-	IF (NOT WIN32)
-		find_package(Threads REQUIRED)
-	ENDIF()
-
-	ADD_DEFINITIONS(-DGIT_THREADS)
-ENDIF()
-
-ADD_DEFINITIONS(-D_FILE_OFFSET_BITS=64)
-
-# Collect sourcefiles
-FILE(GLOB SRC_H include/git2/*.h)
-
-# On Windows use specific platform sources
-IF (WIN32 AND NOT CYGWIN)
-	ADD_DEFINITIONS(-DWIN32 -D_WIN32_WINNT=0x0501)
-	FILE(GLOB SRC_OS src/win32/*.c)
-ELSEIF (AMIGA)
-	ADD_DEFINITIONS(-DNO_ADDRINFO -DNO_READDIR_R)
-	FILE(GLOB SRC_OS src/amiga/*.c)
-ELSE()
-	FILE(GLOB SRC_OS src/unix/*.c)
-ENDIF()
-FILE(GLOB SRC_GIT2 src/*.c src/transports/*.c src/xdiff/*.c)
-
-# Determine architecture of the machine
-IF (CMAKE_SIZEOF_VOID_P EQUAL 8)
-	ADD_DEFINITIONS(-DGIT_ARCH_64)
-ELSEIF (CMAKE_SIZEOF_VOID_P EQUAL 4)
-	ADD_DEFINITIONS(-DGIT_ARCH_32)
-ELSE()
-	message(FATAL_ERROR "Unsupported architecture")
-ENDIF()
-
-# Compile and link libgit2
-ADD_LIBRARY(git2 ${SRC_GIT2} ${SRC_OS} ${SRC_ZLIB} ${SRC_HTTP} ${SRC_REGEX} ${SRC_SHA1} ${WIN_RC})
-TARGET_LINK_LIBRARIES(git2 ${SSL_LIBRARIES})
-TARGET_LINK_LIBRARIES(git2 ${SSH_LIBRARIES})
-TARGET_OS_LIBRARIES(git2)
-
-# Workaround for Cmake bug #0011240 (see http://public.kitware.com/Bug/view.php?id=11240)
-# Win64+MSVC+static libs = linker error
-IF(MSVC AND GIT_ARCH_64 AND NOT BUILD_SHARED_LIBS)
-  SET_TARGET_PROPERTIES(git2 PROPERTIES STATIC_LIBRARY_FLAGS "/MACHINE:x64")
-ENDIF()
-
-MSVC_SPLIT_SOURCES(git2)
-
-IF (SONAME)
-	SET_TARGET_PROPERTIES(git2 PROPERTIES VERSION ${LIBGIT2_VERSION_STRING})
-	SET_TARGET_PROPERTIES(git2 PROPERTIES SOVERSION ${LIBGIT2_VERSION_MAJOR})
-	IF (LIBGIT2_FILENAME)
-		ADD_DEFINITIONS(-DLIBGIT2_FILENAME=\"${LIBGIT2_FILENAME}\")
-		SET_TARGET_PROPERTIES(git2 PROPERTIES OUTPUT_NAME ${LIBGIT2_FILENAME})
-	ENDIF()
-ENDIF()
-CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/libgit2.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libgit2.pc @ONLY)
-
-IF (MSVC_IDE)
-   # Precompiled headers
-   SET_TARGET_PROPERTIES(git2 PROPERTIES COMPILE_FLAGS "/Yuprecompiled.h /FIprecompiled.h")
-   SET_SOURCE_FILES_PROPERTIES(src/win32/precompiled.c COMPILE_FLAGS "/Ycprecompiled.h")
-ENDIF ()
-
-# Install
-INSTALL(TARGETS git2
-	RUNTIME DESTINATION ${BIN_INSTALL_DIR}
-	LIBRARY DESTINATION ${LIB_INSTALL_DIR}
-	ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
-)

=== debian/changelog ===
libgit2 (0.21.1-3~bpo7+1) wheezy-backports; urgency=medium

  * Rebuild for wheezy-backports.

 -- Antoine Beaupré <anarcat@debian.org>  Fri, 05 Jun 2015 10:26:49 -0400

libgit2 (0.21.1-3) jessie; urgency=medium

  * Backported fix for case insensitive filesystems (CVE-2014-9390).
    (Closes: #774048)

 -- Russell Sim <russell.sim@gmail.com>  Tue, 10 Feb 2015 20:29:05 +1100

libgit2 (0.21.1-2.1) jessie; urgency=medium

  * Non-maintainer upload.
  * Use CURDIR instead of PWD to fix the previous upload (Closes: #761539).

 -- Ivo De Decker <ivodd@debian.org>  Thu, 08 Jan 2015 23:51:20 +0100

libgit2 (0.21.1-2) jessie; urgency=medium

  * Fix buildd errors. (Closes: #761539)

 -- Russell Sim <russell.sim@gmail.com>  Sun, 04 Jan 2015 13:13:57 +1100

libgit2 (0.21.1-1) unstable; urgency=medium

  * New upstream release 0.21.1.

 -- Russell Sim <russell.sim@gmail.com>  Wed, 03 Sep 2014 12:41:44 +1000

libgit2 (0.21.0-1) UNRELEASED; urgency=medium

  * New upstream release 0.21.0.
  * debian/copyright: Added new licenses: ICS, CC0.
  * Library name now matches so name version.

 -- Russell Sim <russell.sim@gmail.com>  Sat, 21 Jun 2014 11:19:23 +1000

=== debian/rules ===
--- 
+++ 
@@ -36,6 +36,12 @@
 	dh_auto_install --builddirectory=build-debian-release
 	dh_auto_install --builddirectory=build-debian-devel
 
+override_dh_auto_test:
+	mkdir -p build-debian-release/tmp
+	TMPDIR=$(CURDIR)/build-debian-release/tmp dh_auto_test --builddirectory=build-debian-release
+	mkdir -p build-debian-devel/tmp
+	TMPDIR=$(CURDIR)/build-debian-devel/tmp dh_auto_test --builddirectory=build-debian-devel
+
 override_dh_strip:
 	dh_strip --dbg-package=libgit2-dbg

## libgit2 0.21.3

=== debian/changelog ===
libgit2 (0.21.3-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Use CURDIR instead of PWD to fix the previous upload (Closes: #761539).

 -- Ivo De Decker <ivodd@debian.org>  Thu, 08 Jan 2015 23:04:40 +0100

libgit2 (0.21.3-1) unstable; urgency=medium

  * New upstream release 0.21.3 (CVE-2014-9390) (Closes: #774048).
  * debian/rules: Run tests in a local tmpdir to fix FTBFS (Closes: #761539).

 -- Russell Sim <russell.sim@gmail.com>  Sun, 28 Dec 2014 18:52:18 +1100

libgit2 (0.21.2-2) unstable; urgency=medium

  * debian/control: Added missing dependencies. (Closes: #768482)

 -- Russell Sim <russell.sim@gmail.com>  Sun, 16 Nov 2014 10:33:23 +0100

libgit2 (0.21.2-1) unstable; urgency=medium

  * New upstream release 0.21.2.
  * debian/control: Added libssh2-1-dev requirement. (Closes: #761042)
  * debian/control: Added libhttp-parser-dev requirement.
  * debian/copyright: Fixed MIT NGINX license format.
  * debian/copyright: Reordered file sections.
  * debian/copyright: Fixed incorrect clar licensing.
  * Bumped standards version to 3.9.6 (no change necessary).

 -- Russell Sim <russell.sim@gmail.com>  Tue, 28 Oct 2014 20:34:58 +1100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,9 @@
 Priority: extra
 Maintainer: Russell Sim <russell.sim@gmail.com>
 Build-Depends: debhelper (>= 9.20120417), python-minimal (>= 2.4.0),
-               cmake, libz-dev, libssl-dev, ca-certificates
-Standards-Version: 3.9.5
+               cmake, libz-dev, libssl-dev, libssh2-1-dev, libhttp-parser-dev,
+               ca-certificates
+Standards-Version: 3.9.6
 Homepage: http://libgit2.github.com/
 Vcs-Git: git://anonscm.debian.org/users/arrsim-guest/libgit2.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/arrsim-guest/libgit2.git;a=summary
@@ -14,7 +15,8 @@
 Architecture: any
 Section: libdevel
 Multi-Arch: same
-Depends: libgit2-0 (= ${binary:Version}), libz-dev, libssl-dev,
+Depends: libgit2-21 (= ${binary:Version}), libz-dev,
+         libssl-dev, libssh2-1-dev, libhttp-parser-dev,
          ${shlibs:Depends}, ${misc:Depends}
 Description: low-level Git library (development files)
  libgit2 is a portable, pure C implementation of the Git
@@ -23,7 +25,7 @@
  .
  This package contains the development files for libgit2.
 
-Package: libgit2-0
+Package: libgit2-21
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
@@ -37,7 +39,7 @@
 Section: debug
 Architecture: any
 Multi-Arch: same
-Depends: libgit2-0 (= ${binary:Version}),
+Depends: libgit2-21 (= ${binary:Version}),
          ${misc:Depends}
 Description: libgit2 library and debugging symbols
  libgit2 is a portable, pure C implementation of the Git

## libgit2 0.22.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,12 +19,13 @@
 
 INCLUDE(CheckLibraryExists)
 INCLUDE(AddCFlagIfSupported)
+INCLUDE(FindPkgConfig)
 
 # Build options
 #
 OPTION( SONAME				"Set the (SO)VERSION of the target"		ON  )
 OPTION( BUILD_SHARED_LIBS	"Build Shared Library (OFF for Static)"	ON  )
-OPTION( THREADSAFE			"Build libgit2 as threadsafe"			OFF )
+OPTION( THREADSAFE			"Build libgit2 as threadsafe"			ON )
 OPTION( BUILD_CLAR			"Build Tests using the Clar suite"		ON  )
 OPTION( BUILD_EXAMPLES		"Build library usage example apps"		OFF )
 OPTION( TAGS				"Generate tags"							OFF )
@@ -36,10 +37,12 @@
 
 OPTION( USE_ICONV			"Link with and use iconv library" 		OFF )
 OPTION( USE_SSH				"Link with libssh to enable SSH support" ON )
+OPTION( USE_GSSAPI			"Link with libgssapi for SPNEGO auth"   OFF )
 OPTION( VALGRIND			"Configure build for valgrind"			OFF )
 
 IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
 	SET( USE_ICONV ON )
+	ADD_DEFINITIONS(-DGIT_COMMON_CRYPTO)
 ENDIF()
 
 IF(MSVC)
@@ -58,6 +61,10 @@
 	# By default, libgit2 is built with WinHTTP.  To use the built-in
 	# HTTP transport, invoke CMake with the "-DWINHTTP=OFF" argument.
 	OPTION( WINHTTP			"Use Win32 WinHTTP routines"	ON  )
+
+	# If you want to embed a copy of libssh2 into libgit2, pass a
+	# path to libssh2
+	OPTION( EMBED_SSH_PATH		"Path to libssh2 to embed (Windows)" OFF )
 
 	ADD_DEFINITIONS(-D_SCL_SECURE_NO_WARNINGS)
 	ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)
@@ -133,6 +140,13 @@
 # Find required dependencies
 INCLUDE_DIRECTORIES(src include)
 
+IF (WIN32 AND EMBED_SSH_PATH)
+	FILE(GLOB SRC_SSH "${EMBED_SSH_PATH}/src/*.c")
+	INCLUDE_DIRECTORIES("${EMBED_SSH_PATH}/include")
+	FILE(WRITE "${EMBED_SSH_PATH}/src/libssh2_config.h" "#define HAVE_WINCNG\n#define LIBSSH2_WINCNG\n#include \"../win32/libssh2_config.h\"")
+	ADD_DEFINITIONS(-DGIT_SSH)
+ENDIF()
+
 IF (WIN32 AND WINHTTP AND NOT MINGW)
 	ADD_DEFINITIONS(-DGIT_WINHTTP)
 	INCLUDE_DIRECTORIES(deps/http-parser)
@@ -199,13 +213,21 @@
 
 # Optional external dependency: libssh2
 IF (USE_SSH)
-	FIND_PACKAGE(LIBSSH2)
+	PKG_CHECK_MODULES(LIBSSH2 libssh2)
 ENDIF()
 IF (LIBSSH2_FOUND)
 	ADD_DEFINITIONS(-DGIT_SSH)
 	INCLUDE_DIRECTORIES(${LIBSSH2_INCLUDE_DIR})
 	SET(LIBGIT2_PC_REQUIRES "${LIBGIT2_PC_REQUIRES} libssh2")
 	SET(SSH_LIBRARIES ${LIBSSH2_LIBRARIES})
+ENDIF()
+
+# Optional external dependency: libgssapi
+IF (USE_GSSAPI)
+	FIND_PACKAGE(GSSAPI)
+ENDIF()
+IF (GSSAPI_FOUND)
+	ADD_DEFINITIONS(-DGIT_GSSAPI)
 ENDIF()
 
 # Optional external dependency: iconv
@@ -305,27 +327,3 @@
 		STRING(REGEX REPLACE "-fPIC" "" CMAKE_SHARED_LIBRARY_C_FLAGS "${CMAKE_SHARED_LIBRARY_C_FLAGS}")
 		# MinGW >= 3.14 uses the C99-style stdio functions
 		# automatically, but forks like mingw-w64 still want
-		# us to define this in order to use them
-		ADD_DEFINITIONS(-D__USE_MINGW_ANSI_STDIO=1)
-
-	ELSEIF (BUILD_SHARED_LIBS)
-		ADD_C_FLAG_IF_SUPPORTED(-fvisibility=hidden)
-
-		SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
-	ENDIF ()
-
-	ADD_C_FLAG_IF_SUPPORTED(-Wno-missing-field-initializers)
-	ADD_C_FLAG_IF_SUPPORTED(-Wstrict-aliasing=2)
-	ADD_C_FLAG_IF_SUPPORTED(-Wstrict-prototypes)
-	ADD_C_FLAG_IF_SUPPORTED(-Wdeclaration-after-statement)
-	ADD_C_FLAG_IF_SUPPORTED(-Wno-unused-const-variable)
-	ADD_C_FLAG_IF_SUPPORTED(-Wno-unused-function)
-
-	IF (APPLE) # Apple deprecated OpenSSL
-		ADD_C_FLAG_IF_SUPPORTED(-Wno-deprecated-declarations)
-	ENDIF()
-
-	IF (PROFILE)
-		SET(CMAKE_C_FLAGS "-pg ${CMAKE_C_FLAGS}")
-		SET(CMAKE_EXE_LINKER_FLAGS "-pg ${CMAKE_EXE_LINKER_FLAGS}")
-	ENDIF ()

=== debian/changelog ===
libgit2 (0.22.1-0ubuntu3) vivid; urgency=medium

  * debian/control:
    - Add pkg-config as a build-dep as it's required to detect
      available libraries like libssh2

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Tue, 14 Apr 2015 14:19:48 -0500

libgit2 (0.22.1-0ubuntu2) vivid; urgency=medium

  * Update disable_tests.patch to disable network test

 -- Jonathan Riddell <jriddell@ubuntu.com>  Tue, 17 Mar 2015 15:44:12 +0100

libgit2 (0.22.1-0ubuntu1) vivid; urgency=medium

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Tue, 17 Mar 2015 13:24:52 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: libgit2
 Section: libs
 Priority: extra
-Maintainer: Russell Sim <russell.sim@gmail.com>
+Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
+XSBC-Original-Maintainer: Russell Sim <russell.sim@gmail.com>
 Build-Depends: debhelper (>= 9.20120417), python-minimal (>= 2.4.0),
                cmake, libz-dev, libssl-dev, libssh2-1-dev, libhttp-parser-dev,
-               ca-certificates
+               ca-certificates, pkg-config
 Standards-Version: 3.9.6
 Homepage: http://libgit2.github.com/
 Vcs-Git: git://anonscm.debian.org/users/arrsim-guest/libgit2.git
@@ -15,7 +16,7 @@
 Architecture: any
 Section: libdevel
 Multi-Arch: same
-Depends: libgit2-21 (= ${binary:Version}), libz-dev,
+Depends: libgit2-22 (= ${binary:Version}), libz-dev,
          libssl-dev, libssh2-1-dev, libhttp-parser-dev,
          ${shlibs:Depends}, ${misc:Depends}
 Description: low-level Git library (development files)
@@ -25,7 +26,7 @@
  .
  This package contains the development files for libgit2.
 
-Package: libgit2-21
+Package: libgit2-22
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
@@ -39,7 +40,7 @@
 Section: debug
 Architecture: any
 Multi-Arch: same
-Depends: libgit2-21 (= ${binary:Version}),
+Depends: libgit2-22 (= ${binary:Version}),
          ${misc:Depends}
 Description: libgit2 library and debugging symbols
  libgit2 is a portable, pure C implementation of the Git

=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,7 @@
 #export DH_VERBOSE=1
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+TEST_TMPDIR := $(CURDIR)/tmp-test
 
 override_dh_auto_configure:
 	dh_auto_configure --builddirectory=build-debian-release -- \
@@ -28,11 +29,11 @@
 override_dh_makeshlibs:
 	dh_makeshlibs -V
 
-override_dh_auto_build :
+override_dh_auto_build:
 	dh_auto_build --builddirectory=build-debian-release
 	dh_auto_build --builddirectory=build-debian-devel
 
-override_dh_auto_install :
+override_dh_auto_install:
 	dh_auto_install --builddirectory=build-debian-release
 	dh_auto_install --builddirectory=build-debian-devel

## libgit2 0.22.2

=== debian/changelog ===
libgit2 (0.22.2-2) unstable; urgency=medium

  * debian/control: Added dependency on pkg-config (Closes: #786494)
  * debian/rules: Manually cleanup clar files (Closes: #786491)

 -- Russell Sim <russell.sim@gmail.com>  Sat, 23 May 2015 22:42:04 -0700

libgit2 (0.22.2-1) unstable; urgency=medium

  * New upstream releaase 0.22.2 (Closes: #780495).

 -- Russell Sim <russell.sim@gmail.com>  Wed, 06 May 2015 21:54:25 +1000

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: libgit2
 Section: libs
 Priority: extra
-Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
-XSBC-Original-Maintainer: Russell Sim <russell.sim@gmail.com>
-Build-Depends: debhelper (>= 9.20120417), python-minimal (>= 2.4.0),
+Maintainer: Russell Sim <russell.sim@gmail.com>
+Build-Depends: debhelper (>= 9.20120417), python-minimal (>= 2.4.0), pkg-config,
                cmake, libz-dev, libssl-dev, libssh2-1-dev, libhttp-parser-dev,
-               ca-certificates, pkg-config
+               ca-certificates
 Standards-Version: 3.9.6
 Homepage: http://libgit2.github.com/
 Vcs-Git: git://anonscm.debian.org/users/arrsim-guest/libgit2.git
